include \masm32\include\masm32rt.inc
.686p
.mmx
.xmm

.data?
	hInstance	dd ?
.code

EWR struct
	hWnd	HWND	?
	dwPID	DWORD	?
EWR ends

EnumWindowsProc proc uses esi hWnd:HWND,pEWR:ptr EWR
LOCAL PID:DWORD

	mov esi,pEWR
	.if rv(GetWindowThreadProcessId,hWnd,ADDR PID)
		invoke GetWindowLong,hWnd,GWL_STYLE
		mov edx,PID
		; get first window, which is visible and not a child
		.if edx == [esi].EWR.dwPID && !(eax & WS_CHILD) && eax & WS_VISIBLE
			m2m [esi].EWR.hWnd,hWnd			
			xor eax,eax
			ret
		.endif
	.endif
	
	mov eax,1
	ret
	
EnumWindowsProc endp

main proc 
LOCAL pszFile: ptr CHAR
LOCAL se:SHELLEXECUTEINFO
LOCAL res:EWR
LOCAL sz1[256]:CHAR
LOCAL sz2[256]:CHAR

	mov hInstance,rv(GetModuleHandle,0)
	
	mov pszFile, OpenFileDlg(0,hInstance,"Open File",chr$("All files",0,"*.*",0))
	.if CHAR PTR [eax] != 0
		
		; use ShelExecuteEx to 'open' the file
		invoke RtlZeroMemory,ADDR se,SIZEOF se
		mov se.fMask,SEE_MASK_NOCLOSEPROCESS or SEE_MASK_WAITFORINPUTIDLE
		mov se.cbSize,SIZEOF se
		m2m se.lpFile,pszFile
		mov se.lpVerb,chr$("open")
		mov se.nShow,SW_SHOWNORMAL
		invoke ShellExecuteEx,ADDR se
		
		; se.hProcess is our target process
		mov res.hWnd,0
		mov res.dwPID,rv(GetProcessId,se.hProcess)
		invoke EnumWindows,ADDR EnumWindowsProc,ADDR res
		.if res.hWnd
			invoke GetWindowText,res.hWnd,ADDR sz1,SIZEOF sz1
			invoke GetClassName,res.hWnd,ADDR sz2,SIZEOF sz2
			invoke MessageBox,0,ADDR sz2,ADDR sz1,MB_OK
		.else
			invoke MessageBeep,MB_ICONEXCLAMATION
			exit
		.endif
    .else
		invoke MessageBeep,MB_ICONEXCLAMATION
		exit
	.endif
	exit

main endp

end main
